#include <iostream>

using namespace std;

long long zbircif(long long n){
    long long zbir = 0;
    while(n > 0){
        zbir += n % 10;
        n /= 10;
    }
    return zbir;
}

int main()
{
    long long x, y, a, b;
    cin >> x >> y >> a >> b;
    for(long long s = 1; s <= 162 && s <= 1e18/a; s++){
        long long n = a * s + b;
        if(n >= x && n <= y && zbircif(n) == s){
            cout << n;
            return 0;
        }
    }
    cout << -1;
    return 0;
}